//
//  service delete & list
//
//	 2004/6/25  by takapyu
//
#include <windows.h>
#include <commctrl.h>

#include "resource.h"

// `ƃVXe֘AT[rX폜\
//#define ALL_DELETE		1

#define ID_LISTVIEW	100
#define ID_TOOLBAR	101
#define ID_STATUS	102

// .ini ̃L[
#define INI_SECTION	"sdelist"
#define INI_LEFT	"left"
#define INI_TOP		"top"
#define INI_RIGHT	"right"
#define INI_BOTTOM	"bottom"
#define INI_ITEMWIDE	"itemwide"

// Xgr[̍
#define HEADER_NAME		0	// O
#define HEADER_EXPLAIN	1	// 
#define HEADER_STATUS	2	// 
#define HEADER_STARTUP	3	// X^[gAbv̎
#define HEADER_LOGON	4	// OI
#define HEADER_PATH		5	// pX
#define HEADER_SNAME	6	// 
#define HEADER_PROCESS	7	// 
#define LISTITEM_MAX	8

// c[o[
#define TOOLBUTTON_MAX	12

// |bvAbvj[\̃bZ[W
#define WM_SHOW_POPUP_MENU	WM_USER+1001

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL APIENTRY UndoFunc(HWND hdlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

const char *CLASS_NAME = "sdelist";

// Xgr[̍ږ
char *header[] = {
	"O", "", "", "X^[gAbv̎", "OI", "pX", "", ""
};
// c[o[̃{^
TBBUTTON tbButton[] = {
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 0, ID_MENU_REFRESH, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 1, ID_MENU_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },

	{ 2, ID_MENU_DELETE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 3, ID_MENU_UNDO, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 4, ID_MENU_START, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 5, ID_MENU_STOP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },

	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 6, ID_MENU_ALL, TBSTATE_ENABLED, TBSTYLE_CHECK, 0, 0 },
};
// 낢
// ߂ǂ̂ŃO[oϐ
HINSTANCE hInst;
WNDPROC OldProc;
HWND hMainWnd;		// CEChE
HWND hList;			// Xgr[
HIMAGELIST hImage;	// c[{^̃C[WXg
int item_wide[LISTITEM_MAX];	// ڕ ĂƁ[
char ini_file_path[_MAX_PATH];	// ini t@C̃pX
char his_file_path[_MAX_PATH];	// his t@C̃pX 폜
struct UNDO_LIST {
	struct UNDO_LIST *next;
	char *name;
} *undo_top;

//
//	ini ɐl
//	in: section       .. ZNV
//	    name          .. L[
//	    no            .. ސl
//	    ini_file_path .. t@C
void WritePrivateProfileInt(char *section, char *name, int no, char *ini_file_path)
{
	char temp[100];

	wsprintf(temp, "%d", no);
	WritePrivateProfileString(section, name, temp, ini_file_path);
}

//
//	񂩂w蕶ĈʒuԂ
//	in: pt .. 
//	    ch .. w蕶
//
int strpos(unsigned char *pt, int ch)
{
	int pos;

	if(pt != NULL) {
		pos = 0;
		while(*pt != '\0') {
			if(*pt == ch) {
				return pos;
			}
			pos++;
			pt++;
		}
	}
	return -1;
}

//
//	؂o
//	in: dst   .. ؂o镶̃obt@
//	    src   .. ̃̕obt@
//	    token .. ؂蕶
//	    max   .. ؂o镶̍ő咷
//
char *strtoken(char *dst, char *src, char *token, int max)
{
	if(src == NULL) {
		return NULL;
	}
	while(strpos(token, *src) != -1) {
		src++;
	}
	if(*src == '\0') {
		*dst = '\0';
		return NULL;
	}
	while(max > 0 && *src != '\0') {
		*dst = *src;
		if(strpos(token, *src) != -1) {
			*dst = '\0';
			while(strpos(token, *src) != -1) {
				src++;
			}
			return src;
		}
		src++;
		dst++;
		max--;
	}
	*dst = '\0';
	return src;
}

//
//	؂o csv p
//	in: dst   .. ؂o镶̃obt@
//	    src   .. ̃̕obt@
//	    token .. ؂蕶
//	    max   .. ؂o镶̍ő咷
//
char *strtokencsv(char *dst, char *src, char *token, int max)
{
	if(src == NULL) {
		return NULL;
	}
	if(*src == '\0') {
		return NULL;
	}
	while(max > 0 && *src != '\0') {
		*dst = *src;
		if(strpos(token, *src) != -1) {
			*dst = '\0';
			return src + 1;
		}
		src++;
		dst++;
		max--;
	}
	*dst = '\0';
	return src;
}

//
//	gqo
//	in: path .. pX
//	out: gq̐擪|C^
//
char *extract_ext(char *path)
{
	int len;
	unsigned char *pt;

	len = strlen(path);
	pt = path + len - 1;
	while(pt != path) {
		if(*pt == '.') {
			return pt + 1;
		}
		if(*pt == '\\' || *pt == '/' || *pt == ':') {
			return path + len;
		}
		pt--;
	}
	return pt;
}

//
//	_CAOeEChE(hMainWnd)̒ɕ\
//	in: hDlg .. _CAÕnh
//
void set_dialog_center(HWND hDlg)
{
	RECT rp, rc;
	int left, top;

	GetWindowRect(hMainWnd, &rp);
	GetWindowRect(hDlg, &rc);
	left = rp.left + ((rp.right - rp.left) - (rc.right - rc.left)) / 2;
	top = rp.top + ((rp.bottom - rp.top) - (rc.bottom - rc.top)) / 2;
	MoveWindow(hDlg, left, top, rc.right - rc.left, rc.bottom - rc.top, TRUE);
}

//
//	undo p̃Xgɒǉ
//	in: name .. ǉ镶
//
void add_undo(char *name)
{
	struct UNDO_LIST *new, *undo;

	if((new = (struct UNDO_LIST *)LocalAlloc(LPTR, sizeof(struct UNDO_LIST))) != NULL) {
		if((new->name = (char *)LocalAlloc(LPTR, strlen(name) + 1)) != NULL) {
			lstrcpy(new->name, name);
			new->next = NULL;
			if(undo_top == NULL) {
				undo_top = new;
			} else {
				undo = undo_top;
				while(undo->next != NULL) {
					undo = undo->next;
				}
				undo->next = new;
			}
		} else {
			LocalFree(new);
		}
	}
}

//
//	undo p̃Xg폜
//	in: dno .. 폜郊Xgԍ
//
void delete_undo(int dno)
{
	int no;
	struct UNDO_LIST *now, *last;

	if(undo_top != NULL) {
		if(dno == 0) {
			now = undo_top;
			undo_top = now->next;
			LocalFree(now->name);
			LocalFree(now);
		} else {
			last = undo_top;
			now = undo_top->next;
			no = 0;
			while(now != NULL) {
				no++;
				if(no == dno) {
					last->next = now->next;
					LocalFree(now->name);
					LocalFree(now);
					break;
				}
				last = now;
				now = now->next;
			}
		}
	}
}

//
//	Xgr[̓e undo Xgɒǉ
//	in: hList .. Xgr[̃nh
//	    no    .. ǉXgr[̍sԍ
//
void add_history(HWND hList, int no)
{
	int ino, size;
	char name[LISTITEM_MAX][_MAX_PATH];
	char *pt;

	size = 0;
	for(ino = 0 ; ino < LISTITEM_MAX ; ino++) {
		ListView_GetItemText(hList, no, ino, name[ino], _MAX_PATH);
		size += strlen(name[ino]) + 1;
	}
	if((pt = (char *)LocalAlloc(LPTR, size + 1)) != NULL) {
		*pt = '\0';
		for(ino = 0 ; ino < LISTITEM_MAX ; ino++) {
			lstrcat(pt, name[ino]);
			if(ino < LISTITEM_MAX - 1) {
				lstrcat(pt, ",");
			}
		}
		add_undo(pt);
		LocalFree(pt);
	}
}

//
//	undo Xgt@Cɕۑ
//
void write_history(void)
{
	struct UNDO_LIST *undo;
	int size;
	HANDLE hfp;

	if(undo_top == NULL) {
		DeleteFile(his_file_path);
	} else {
		if((hfp = CreateFile(his_file_path, GENERIC_WRITE, 0, NULL, TRUNCATE_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)) == INVALID_HANDLE_VALUE) {
			hfp = CreateFile(his_file_path, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, 0);
		}
		if(hfp != INVALID_HANDLE_VALUE) {
			undo = undo_top;
			while(undo != NULL) {
				WriteFile(hfp, undo->name, strlen(undo->name), &size, NULL);
				WriteFile(hfp, "\r\n", 2, &size, NULL);
				undo = undo->next;
			}
			CloseHandle(hfp);
		}
	}
}

//
//	undo Xg݂邩
//	in: hWnd  .. CEChẼnh
//	    hTool .. c[o[̃nh
//
void check_history(HWND hWnd, HWND hTool)
{
	HMENU hMenu = GetMenu(hWnd);

	if(undo_top != NULL) {
		SendMessage(hTool, TB_SETSTATE, ID_MENU_UNDO, TBSTATE_ENABLED);
		EnableMenuItem(hMenu, ID_MENU_UNDO, MF_ENABLED);
	} else {
		SendMessage(hTool, TB_SETSTATE, ID_MENU_UNDO, TBSTATE_INDETERMINATE);
		EnableMenuItem(hMenu, ID_MENU_UNDO, MF_GRAYED);
	}
	
}

//
//	ׂĂ undo Xg폜
//
void delete_all_undo(void)
{
	struct UNDO_LIST *undo, *next;

	undo = undo_top;
	while(undo != NULL) {
		next = undo->next;
		if(undo->name != NULL) {
			LocalFree(undo->name);
		}
		LocalFree(undo);
		undo = next;
	}
}

//
//	ini t@CɐݒۑiEChEʒuAڕ)
//	in: hWnd  .. CEChẼnh
//	    hList .. Xgr[̃nh
//
void write_ini(HWND hWnd, HWND hList)
{
	char name[_MAX_PATH];
	RECT rec;
	int no, wide;

	GetWindowRect(hWnd, &rec);
	WritePrivateProfileInt(INI_SECTION, INI_LEFT, rec.left, ini_file_path);
	WritePrivateProfileInt(INI_SECTION, INI_TOP, rec.top, ini_file_path);
	WritePrivateProfileInt(INI_SECTION, INI_RIGHT, rec.right, ini_file_path);
	WritePrivateProfileInt(INI_SECTION, INI_BOTTOM, rec.bottom, ini_file_path);

	for(no = 0 ; no < LISTITEM_MAX ; no++) {
		wide = ListView_GetColumnWidth(hList, no);
		wsprintf(name, "%s%d", INI_ITEMWIDE, no);
		WritePrivateProfileInt(INI_SECTION, name, wide, ini_file_path);
	}

}

//
//	T[rXet@Cɏo
//	in: hWnd  .. CEChẼnh
//	    hList .. Xgr[̃nh
//
void write_csv(HWND hWnd, HWND hList)
{
	int no, ino, count, size, flag;
	char temp[_MAX_PATH];
	char name[_MAX_PATH];
	char *pt;
    OPENFILENAME ofn;
	HANDLE hfp;

	name[0] = '\0';
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = "eLXg (J}ŋ؂ꂽt@C)( *.csv)\0*.csv\0eLXg (^uŋ؂ꂽt@C) (*.txt)\0*.txt\0\0";
	ofn.lpstrFile = name;
	ofn.nFilterIndex = 1;
	ofn.nMaxFile = sizeof(name);
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "csv";

	if(GetSaveFileName(&ofn)) {
		if((hfp = CreateFile(name, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)) != INVALID_HANDLE_VALUE) {
			flag = stricmp(extract_ext(name), "txt");
			count = ListView_GetItemCount(hList);
			for(no = -1 ; no < count ; no++) {
				for(ino = 0 ; ino < LISTITEM_MAX ; ino++) {
					if(no == -1) {
						lstrcpy(temp, header[ino]);
					} else {
						ListView_GetItemText(hList, no, ino, temp, _MAX_PATH);
					}
					if(flag && strpos(temp, ',') != -1) {
						WriteFile(hfp, "\"", 1, &size, NULL);
					}
					pt = temp;
					do {
						pt = strtoken(name, pt, "\r\n", _MAX_PATH);
						if(name[0] != '\0') {
							WriteFile(hfp, name, strlen(name), &size, NULL);
						}
					} while(pt != NULL);
					if(flag && strpos(temp, ',') != -1) {
						WriteFile(hfp, "\"", 1, &size, NULL);
					}
					if(ino < LISTITEM_MAX - 1) {
						if(flag) {
							WriteFile(hfp, ",", 1, &size, NULL);
						} else {
							WriteFile(hfp, "\t", 1, &size, NULL);
						}
					}
				}
				WriteFile(hfp, "\r\n", 2, &size, NULL);
			}
			CloseHandle(hfp);
		}
	}
}

//
//	ini t@Cݒǂݏo
//	in: rec .. EChEʒui[ϐ
//
void read_ini(RECT *rec)
{
	char name[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char directory[_MAX_DIR];
	char extension[_MAX_EXT];
	char fname[_MAX_FNAME];
	int no, size;
	HANDLE hfp;
	char *pt, *rpt;

	GetModuleFileName(NULL, name, sizeof(name));
	_splitpath(name, drive, directory, fname, extension);
	_makepath(ini_file_path, drive, directory, fname, ".ini");
	_makepath(his_file_path, drive, directory, fname, ".his");

	rec->left = GetPrivateProfileInt(INI_SECTION, INI_LEFT, CW_USEDEFAULT, ini_file_path);
	rec->top = GetPrivateProfileInt(INI_SECTION, INI_TOP, CW_USEDEFAULT, ini_file_path);
	rec->right = GetPrivateProfileInt(INI_SECTION, INI_RIGHT, CW_USEDEFAULT, ini_file_path);
	rec->bottom = GetPrivateProfileInt(INI_SECTION, INI_BOTTOM, CW_USEDEFAULT, ini_file_path);
	for(no = 0 ; no < LISTITEM_MAX ; no++) {
		wsprintf(name, "%s%d", INI_ITEMWIDE, no);
		item_wide[no] = GetPrivateProfileInt(INI_SECTION, name, 0, ini_file_path);
	}
	undo_top = NULL;
	if((hfp = CreateFile(his_file_path, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)) != INVALID_HANDLE_VALUE) {
		size = GetFileSize(hfp, NULL);
		if((pt = (char *)LocalAlloc(LPTR, size + 1)) != NULL) {
			ReadFile(hfp, pt, size, &no, NULL);
			*(pt + size) = '\0';
			rpt = pt;
			while(*rpt != '\0') {
				rpt = strtoken(name, rpt, "\r\n", _MAX_PATH);
				add_undo(name);
			}
		}
		LocalFree(pt);
		CloseHandle(hfp);
	}
}

//
//	T[rXJn
//	in: sname .. T[rX
//	out: TRUE:, FALSE:s
//
int start_service(char *sname)
{
	SC_HANDLE scm, sc;
	int ret;
	
	ret = FALSE;
	if((scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE))) {
		if((sc = OpenService(scm, sname, SERVICE_ALL_ACCESS))) {
			if(StartService(sc, 0, NULL)) {
				ret = TRUE;
			}
			CloseServiceHandle(sc);
		}
		CloseServiceHandle(scm);
	}
	return ret;
}

//
//	T[rX~
//	in: sname .. T[rX
//	out: TRUE:, FALSE:s
//
int stop_service(char *sname)
{
	SC_HANDLE scm, sc;
	SERVICE_STATUS st;
	int count, ret;
	
	ret = FALSE;
	if((scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE))) {
		if((sc = OpenService(scm, sname, SERVICE_ALL_ACCESS))) {
			if(ControlService(sc, SERVICE_CONTROL_STOP, &st)) {
				count = 0;
				while(count < 10) {
					if(QueryServiceStatus(sc, &st)) {
						if(st.dwCurrentState == SERVICE_STOPPED) {
							ret = TRUE;
							break;
						}
					}
					Sleep(500);
					count++;
				}
			}
			CloseServiceHandle(sc);
		}
		CloseServiceHandle(scm);
	}
	return ret;
}

//
//	T[rX폜
//	in: sname .. T[rX
//	out: TRUE:, FALSE:s
//
int delete_service(char *sname)
{
	SC_HANDLE scm, sc;
	SERVICE_STATUS st;
	int count, ret;

	ret = FALSE;
	if((scm = OpenSCManager(0, 0, SC_MANAGER_ALL_ACCESS))) {
		if((sc = OpenService(scm, sname, SERVICE_ALL_ACCESS | DELETE))) {
			if(QueryServiceStatus(sc, &st)) {
				if(st.dwCurrentState != SERVICE_STOPPED) {
					if(ControlService(sc, SERVICE_CONTROL_STOP, &st)) {
						count = 0;
						while(count < 10) {
							if(QueryServiceStatus(sc, &st)) {
								if(st.dwCurrentState == SERVICE_STOPPED) {
									break;
								}
							}
							Sleep(500);
							count++;
						}
					}
				}
			}
			if(DeleteService(sc)) {
				ret = TRUE;
			}
			CloseServiceHandle(sc);
		}
		CloseServiceHandle(scm);
	}
	return ret;
}

//
//	T[rX폜ł邩H
//	in: hWnd  .. CEChẼnh
//	    hList .. Xgr[̃nh
//	    no    .. 폜ڂ̍sԍ
//	out: TRUE:폜, FALSE:폜s
//
int check_delete_service(HWND hWnd, HWND hList, int no)
{
	ENUM_SERVICE_STATUS es;
	SC_HANDLE scm, sc;
	char sname[_MAX_PATH], name[_MAX_PATH], temp[_MAX_PATH], path[_MAX_PATH];
	DWORD count, size;
	LPQUERY_SERVICE_CONFIG buff;
	int ret, flag;

	ret = TRUE;
	ListView_GetItemText(hList, no, HEADER_NAME, name, _MAX_PATH);
	// foCXhCo or t@CVXehCo
	ListView_GetItemText(hList, no, HEADER_PROCESS, temp, _MAX_PATH);
	if(!strcmp(temp, "foCXhCo") || !strcmp(temp, "t@CVXehCo")) {
#ifdef ALL_DELETE
		wsprintf(temp, "%s ̓foCXhCołB\r\nVXeNłȂȂ铙̕s\܂B\r\nč폜T[rX͂̕łȂƎv܂A폜܂H", name);
		if(MessageBox(hWnd, temp, "폜", MB_YESNO | MB_ICONEXCLAMATION) == IDNO) {
			ret = FALSE;
		}
#else
		wsprintf(temp, "%s ̓foCXhCôߍ폜ł܂B", name);
		MessageBox(hWnd, temp, "G[", MB_OK | MB_ICONEXCLAMATION);
		ret = FALSE;
#endif
	} else {
		ListView_GetItemText(hList, no, HEADER_PATH, path, _MAX_PATH);
		GetSystemDirectory(temp, _MAX_PATH);
		// VXetH_̉Ɏst@C݂邩H
		if(!strnicmp(temp, path, strlen(temp))) {
			// 邩H
			ListView_GetItemText(hList, no, HEADER_EXPLAIN, temp, _MAX_PATH);
			if(temp[0] != '\0') {
				// 2006/11/2
				wsprintf(temp, "%s ̓VXe֌W̃T[rXƎv܂B\r\nVXeNłȂȂ铙̕s\܂B\r\n폜Ă낵łH", name);
				if(MessageBox(hWnd, temp, "폜", MB_YESNO | MB_ICONEXCLAMATION) == IDNO) {
					ret = FALSE;
				}
			} else {
				wsprintf(temp, "%s ̓VXe֌W̃T[rXƎv܂B\r\nVXeNłȂȂ铙̕s\܂B\r\n폜Ă낵łH", name);
				if(MessageBox(hWnd, temp, "폜", MB_YESNO | MB_ICONEXCLAMATION) == IDNO) {
					ret = FALSE;
				}
			}
		}
		if(ret) {
			ListView_GetItemText(hList, no, HEADER_SNAME, sname, _MAX_PATH);
			if((scm = OpenSCManager(0, 0, SC_MANAGER_ALL_ACCESS))) {
				if((sc = OpenService(scm, sname, SERVICE_QUERY_CONFIG | SERVICE_ENUMERATE_DEPENDENTS))) {
					// Ƃ肠obt@Pœǂł݂
					EnumDependentServices(sc, SERVICE_ACTIVE | SERVICE_INACTIVE, &es, sizeof(es), &size, &count);
					// TCY 0 łȂΈˑT[rXƔf
					if(size > 0) {
#ifdef ALL_DELETE
						wsprintf(temp, "%s ɈˑT[rX܂B\r\nVXeNłȂȂ铙̕s\܂B\r\n폜Ă낵łH", name);
						if(MessageBox(hWnd, temp, "폜", MB_YESNO | MB_ICONEXCLAMATION) == IDNO) {
							ret = FALSE;
						}
#else
						wsprintf(temp, "%s ɈˑT[rX邽ߍ폜ł܂B", name);
						MessageBox(hWnd, temp, "G[", MB_OK | MB_ICONEXCLAMATION);
						ret = FALSE;
#endif
					} else {
						// [hƈˑ֌W邩H
						QueryServiceConfig(sc, 0, 0, &size);
						buff = (LPQUERY_SERVICE_CONFIG)LocalAlloc(LPTR, size);
						QueryServiceConfig(sc, buff, size, &size);
						flag = FALSE;
						if(buff->lpLoadOrderGroup != NULL) {
							if(buff->lpLoadOrderGroup[0] != '\0') {
								flag = TRUE;
							}
						}
						if(buff->lpDependencies != NULL) {
							if(buff->lpDependencies[0] != '\0') {
								flag = TRUE;
							}
						}
						// ΍폜ĂĂ݂
						// 폜Ƀ[hƂۑĂ
						// ߂񂾂낤ǖʓ|Ȃ̂ł
						if(flag) {
							if(MessageBox(hWnd, "T[rX̃[hƈˑ֌W͕ł܂񂪁A폜܂H", "폜", MB_YESNO | MB_ICONEXCLAMATION) == IDNO) {
								ret = FALSE;
							}
						}
						LocalFree(buff);
					}
					CloseServiceHandle(sc);
				}
			}
			CloseServiceHandle(scm);
		}
	}
	return ret;
}

//
//	T[rX
//	in: hList .. Xgr[̃nh
//	    no    .. ڂ̍sԍ
//	out: TRUE:, FALSE:s
//
int undo_service(HWND hDlg, HWND hList, int no)
{
	SC_HANDLE scm, sc;
	char temp[_MAX_PATH];
	char name[_MAX_PATH];
	char sname[_MAX_PATH];
	char path[_MAX_PATH];
	char account[_MAX_PATH];
	DWORD start, type;
	int ret, flag;

	ret = FALSE;

	ListView_GetItemText(hList, no, HEADER_NAME, name, _MAX_PATH);
	ListView_GetItemText(hList, no, HEADER_STATUS, temp, _MAX_PATH);
	if(!strcmp(temp, "Jn")) {
		flag = TRUE;
	} else {
		flag = FALSE;
	}
	ListView_GetItemText(hList, no, HEADER_STARTUP, temp, _MAX_PATH);
	if(!strcmp(temp, "")) {
		start = SERVICE_AUTO_START;
	} else if(!strcmp(temp, "u[g")) {
		start = SERVICE_BOOT_START;
	} else if(!strcmp(temp, "VXe")) {
		start = SERVICE_SYSTEM_START;
	} else if(!strcmp(temp, "")) {
		start = SERVICE_DISABLED;
	} else {
		start = SERVICE_DEMAND_START;
	}
	ListView_GetItemText(hList, no, HEADER_PROCESS, temp, _MAX_PATH);
	type = SERVICE_WIN32_OWN_PROCESS;
	if(!strncmp(temp, "ƎvZX", 12)) {
		type = SERVICE_WIN32_OWN_PROCESS;
		if(!strncmp(&temp[12], "(Θb)", 10)) {
			type |= SERVICE_INTERACTIVE_PROCESS;
		}
	} else if(!strncmp(temp, "LvZX", 12)) {
		type = SERVICE_WIN32_SHARE_PROCESS;
		if(!strncmp(&temp[12], "(Θb)", 10)) {
			type |= SERVICE_INTERACTIVE_PROCESS;
		}
	} else if(!strcmp(temp, "foCXhCo")) {
		type = SERVICE_KERNEL_DRIVER;
	} else if(!strcmp(temp, "t@CVXehCo")) {
		type = SERVICE_FILE_SYSTEM_DRIVER;
	}
	ListView_GetItemText(hList, no, HEADER_LOGON, account, _MAX_PATH);
	ListView_GetItemText(hList, no, HEADER_PATH, path, _MAX_PATH);
	ListView_GetItemText(hList, no, HEADER_SNAME, sname, _MAX_PATH);
	if((scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE))) {
		if((sc = CreateService(scm, sname, name,
							SERVICE_ALL_ACCESS,
							type,
							start,
							SERVICE_ERROR_NORMAL,
							path,
							NULL, NULL, NULL, account, NULL))) {
			if(flag) {
				StartService(sc, 0, NULL);
			}
			CloseServiceHandle(sc);
			delete_undo(no);
			ret = TRUE;
		} else {
			wsprintf(temp, "%s ̕Ɏs܂B", name);
			MessageBox(hDlg, temp, "G[", MB_OK | MB_ICONSTOP);
			SetFocus(hList);
		}
		CloseServiceHandle(scm);
	}
	return ret;
}

//
//	c[o[̏
//	in: hWnd  .. CEChẼnh
//	out: c[o[̃nh
//
HWND init_toolbar(HWND hWnd)
{
	HWND hTool;
	int no;

	hTool = CreateWindowEx(0,
	  TOOLBARCLASSNAME,
	  NULL,
	  WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS,
	  0, 0, 0, 0,
	  hWnd,
	  (HMENU)ID_TOOLBAR,
	  hInst,
	  NULL);	  

    SendMessage(hTool, TB_BUTTONSTRUCTSIZE, 0, sizeof(tbButton));
    hImage = ImageList_LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP_TOOLBAR),
        16, 15, RGB(0, 255, 0));
    SendMessage(hTool, TB_SETIMAGELIST, 0, (LPARAM)hImage);

	for(no = 0 ; no < TOOLBUTTON_MAX ; no++) {
		SendMessage(hTool, TB_INSERTBUTTON, no, (LPARAM)&tbButton[no]);
	}
	return hTool;
}

//
//	Xe[^Xo[̏
//	 悭悭lƂȂɂ\ĂȂȁB
//	in: hWnd  .. CEChẼnh
//	out: Xe[^Xo[̃nh
//
HWND init_status(HWND hWnd)
{
	HWND hStatus;
	hStatus = CreateWindowEx(0, STATUSCLASSNAME, NULL
	  , WS_CHILD | SBARS_SIZEGRIP | CCS_BOTTOM | WS_VISIBLE
	  , 0, 0, 0, 0, hWnd, (HMENU)ID_STATUS, hInst, NULL);
	SendMessage(hStatus, SB_SIMPLE, TRUE, 0L);
	return hStatus;
}

//
// Xgr[ɃT[rX̏ǉ
//	in: hList  .. Xgr[̃nh
//
void add_listview(HWND hList, BOOL flag)
{
	SC_HANDLE scm, sc;
	BOOL success;
	LPENUM_SERVICE_STATUS status;
	DWORD no, size, resume, count, type;
	LV_ITEM lvi;
	LPQUERY_SERVICE_CONFIG buff;
	HKEY hkey;
	char temp[_MAX_PATH], exp[_MAX_PATH];

	ListView_DeleteAllItems(hList);

	scm = OpenSCManager(0, 0, SC_MANAGER_ALL_ACCESS);
	if(!scm) {
		return;
	}

	if(flag) {
		type = SERVICE_WIN32 | SERVICE_DRIVER;
	} else {
		type = SERVICE_WIN32;
	}
	resume = 0;
	success = EnumServicesStatus(scm, type
	 , SERVICE_ACTIVE | SERVICE_INACTIVE,0, 0, &size, &no, &resume);
	status = (LPENUM_SERVICE_STATUS)LocalAlloc(LPTR, size);

	resume = 0;
	success = EnumServicesStatus(scm, type
	 , SERVICE_ACTIVE | SERVICE_INACTIVE, status, size, &size, &no, &resume);
	for(count = 0; count < no ; count++) {
		sc = OpenService(scm, status[count].lpServiceName, SERVICE_QUERY_CONFIG);
		QueryServiceConfig(sc, 0, 0, &size);
		buff = (LPQUERY_SERVICE_CONFIG)LocalAlloc(LPTR, size);
		QueryServiceConfig(sc, buff, size, &size);

		lvi.mask = LVIF_TEXT | LVIF_PARAM;
		lvi.iItem = count;
		lvi.iSubItem = 0;
		lvi.pszText = status[count].lpDisplayName;
		lvi.lParam = count;
		ListView_InsertItem(hList, &lvi);

		exp[0] = '\0';
		wsprintf(temp, "SYSTEM\\CurrentControlSet\\Services\\%s", status[count].lpServiceName);
		if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, temp, 0, KEY_READ, &hkey) == ERROR_SUCCESS) {
			type = REG_SZ;
			size = _MAX_PATH;
			RegQueryValueEx(hkey, "Description", 0, &type, exp, &size);
			RegCloseKey(hkey);

			ListView_SetItemText(hList, count, HEADER_EXPLAIN, exp);
		}

		temp[0] = '\0';
		if(status[count].ServiceStatus.dwCurrentState == SERVICE_START_PENDING) {
			lstrcpy(temp, "Jn");
		} else if(status[count].ServiceStatus.dwCurrentState == SERVICE_RUNNING) {
			lstrcpy(temp, "Jn");
		}
		ListView_SetItemText(hList, count, HEADER_STATUS, temp);

		if(buff->dwStartType == SERVICE_AUTO_START) {
			lstrcpy(temp, "");
		} else if(buff->dwStartType == SERVICE_DEMAND_START) {
			lstrcpy(temp, "蓮");
		} else if(buff->dwStartType == SERVICE_DISABLED) {
			lstrcpy(temp, "");
		} else if(buff->dwStartType == SERVICE_BOOT_START) {
			lstrcpy(temp, "u[g");
		} else if(buff->dwStartType == SERVICE_SYSTEM_START) {
			lstrcpy(temp, "VXe");
		}
		ListView_SetItemText(hList, count, HEADER_STARTUP, temp);

		ListView_SetItemText(hList, count, HEADER_LOGON, buff->lpServiceStartName);
		ListView_SetItemText(hList, count, HEADER_PATH, buff->lpBinaryPathName);
		ListView_SetItemText(hList, count, HEADER_SNAME, status[count].lpServiceName);

		if(status[count].ServiceStatus.dwServiceType & SERVICE_WIN32_OWN_PROCESS) {
			wsprintf(temp, "ƎvZX", status[count].ServiceStatus.dwServiceType);
		} else if(status[count].ServiceStatus.dwServiceType & SERVICE_WIN32_SHARE_PROCESS) {
			wsprintf(temp, "LvZX", status[count].ServiceStatus.dwServiceType);
		} else if(status[count].ServiceStatus.dwServiceType == SERVICE_KERNEL_DRIVER) {
			lstrcpy(temp, "foCXhCo");
		} else if(status[count].ServiceStatus.dwServiceType == SERVICE_FILE_SYSTEM_DRIVER) {
			lstrcpy(temp, "t@CVXehCo");
		}
		if(status[count].ServiceStatus.dwServiceType & SERVICE_INTERACTIVE_PROCESS) {
			lstrcat(temp, "(Θb)");
		}
		ListView_SetItemText(hList, count, HEADER_PROCESS, temp);

		LocalFree(buff);
		CloseServiceHandle(sc);
	}
	LocalFree(status);
	CloseServiceHandle(scm);
}

//
//	Xgr[̏
//	in: hWnd  .. CEChẼnh
//	out: Xgr[̃nh
//
HWND init_listview(HWND hWnd)
{
	HWND hList;
	LV_COLUMN lvcol;
	DWORD data;
	RECT rec;
	int width, no;

	hList = CreateWindowEx(0, WC_LISTVIEW, ""
	 , WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_SINGLESEL
	 , 0, 0, 0, 0
	 , hWnd, (HMENU)ID_LISTVIEW, hInst, NULL);
	data = ListView_GetExtendedListViewStyle(hList);
	data |= LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT;
	ListView_SetExtendedListViewStyle(hList, data);

	GetClientRect(hWnd, &rec);
	rec.right -= GetSystemMetrics(SM_CXVSCROLL);
	width = rec.right - rec.left + 1;
	for(no = 0 ; no < LISTITEM_MAX ; no++) {
		if(item_wide[no] == 0) {
			if(no == HEADER_NAME || no == HEADER_PATH) {
				// \ or pX
				item_wide[no] = width / 13 * 3;
			} else if(no == HEADER_EXPLAIN) {
				// 
				item_wide[no] = width / 13 * 2;
			} else {
				item_wide[no] = width / 13;
			}
		}
	}
	lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.cx = item_wide[0];
	lvcol.pszText = "O";
	lvcol.iSubItem = 0;
	ListView_InsertColumn(hList, 0, &lvcol);

	for(no = 1 ; no < LISTITEM_MAX ; no++) {
		lvcol.cx = item_wide[no];
		lvcol.pszText = header[no];
		lvcol.iSubItem = no;
		ListView_InsertColumn(hList, no, &lvcol);
	}
	return hList;
}

//
//	_CAÕXgr[
//	in: hDlg  .. _CAÕnh
//	out: Xgr[̃nh
//
HWND init_undo_listview(HWND hDlg)
{
	HWND hList;
	LV_COLUMN lvcol;
	LV_ITEM lvi;
	RECT rec;
	DWORD data;
	int width, no, count;
	char *pt;
	char temp[_MAX_PATH];
	struct UNDO_LIST *undo;

	hList = GetDlgItem(hDlg, IDC_LIST_UNDO);
	data = ListView_GetExtendedListViewStyle(hList);
	data |= LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT;
	ListView_SetExtendedListViewStyle(hList, data);
	GetClientRect(hList, &rec);
	//rec.right -= GetSystemMetrics(SM_CXVSCROLL);
	width = (rec.right - rec.left + 1) / 11;

	lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.cx = width * 3;
	lvcol.pszText = "O";
	lvcol.iSubItem = 0;
	ListView_InsertColumn(hList, 0, &lvcol);

	for(no = 1 ; no < LISTITEM_MAX ; no++) {
		if(no != HEADER_PATH) {
			lvcol.cx = width;
		} else {
			lvcol.cx = width * 2;
		}
		lvcol.pszText = header[no];
		lvcol.iSubItem = no;
		ListView_InsertColumn(hList, no, &lvcol);
	}
	count = 0;
	undo = undo_top;
	while(undo != NULL) {
		pt = undo->name;
		for(no = 0 ; no < LISTITEM_MAX ; no++) {
			pt = strtokencsv(temp, pt, ",", _MAX_PATH);
			if(no == 0) {
				lvi.mask = LVIF_TEXT | LVIF_PARAM;
				lvi.iItem = count;
				lvi.iSubItem = 0;
				lvi.pszText = temp;
				lvi.lParam = count;
				ListView_InsertItem(hList, &lvi);
			} else {
				ListView_SetItemText(hList, count, no, temp);
			}
		}
		count++;
		undo = undo->next;
	}

	return hList;
}

//
//	폜JnAI{^ enable/disable
//	in: hWnd  .. CEChẼnh
//	    hList .. Xgr[̃nh
//	    hTool .. c[o[̃nh
//
void check_delete_button(HWND hWnd, HWND hList, HWND hTool)
{
	int no;
	HMENU hMenu = GetMenu(hWnd);
	char temp[_MAX_PATH];

	if((no = ListView_GetNextItem(hList, -1, LVNI_SELECTED)) >= 0) {
		SendMessage(hTool, TB_SETSTATE, ID_MENU_DELETE, TBSTATE_ENABLED);
		EnableMenuItem(hMenu, ID_MENU_DELETE, MF_ENABLED);
		ListView_GetItemText(hList, no, HEADER_STATUS, temp, _MAX_PATH);
		if(!strcmp(temp, "Jn")) {
			SendMessage(hTool, TB_SETSTATE, ID_MENU_START, TBSTATE_INDETERMINATE);
			EnableMenuItem(hMenu, ID_MENU_START, MF_GRAYED);
			SendMessage(hTool, TB_SETSTATE, ID_MENU_STOP, TBSTATE_ENABLED);
			EnableMenuItem(hMenu, ID_MENU_STOP, MF_ENABLED);
		} else {
			SendMessage(hTool, TB_SETSTATE, ID_MENU_START, TBSTATE_ENABLED);
			EnableMenuItem(hMenu, ID_MENU_START, MF_ENABLED);
			SendMessage(hTool, TB_SETSTATE, ID_MENU_STOP, TBSTATE_INDETERMINATE);
			EnableMenuItem(hMenu, ID_MENU_STOP, MF_GRAYED);
		}
	} else {
		SendMessage(hTool, TB_SETSTATE, ID_MENU_DELETE, TBSTATE_INDETERMINATE);
		EnableMenuItem(hMenu, ID_MENU_DELETE, MF_GRAYED);
		SendMessage(hTool, TB_SETSTATE, ID_MENU_START, TBSTATE_INDETERMINATE);
		EnableMenuItem(hMenu, ID_MENU_START, MF_GRAYED);
		SendMessage(hTool, TB_SETSTATE, ID_MENU_STOP, TBSTATE_INDETERMINATE);
		EnableMenuItem(hMenu, ID_MENU_STOP, MF_GRAYED);
	}
}

//
//	WinMain
//
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	WNDCLASS wc;
	HWND hWnd;
	RECT rec;
	int width, height;
	OSVERSIONINFO ovi;

	ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&ovi);
	if(ovi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		if(!hPrevInstance) {
			wc.style = 0; //CS_HREDRAW | CS_VREDRAW;
			wc.lpfnWndProc = WndProc;
			wc.cbClsExtra = 0;
			wc.cbWndExtra = 0;
			wc.hInstance = hInstance;
			wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
			wc.hCursor = LoadCursor(NULL, IDC_ARROW);
			wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
			wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU_MAIN);
			wc.lpszClassName = (LPCSTR)CLASS_NAME;
			RegisterClass(&wc);
		}
		read_ini(&rec);
		if(rec.left == CW_USEDEFAULT || rec.right == CW_USEDEFAULT) {
			width = CW_USEDEFAULT;
		} else {
			width = rec.right - rec.left + 1;
		}
		if(rec.top == CW_USEDEFAULT || rec.bottom == CW_USEDEFAULT) {
			height = CW_USEDEFAULT;
		} else {
			height = rec.bottom - rec.top + 1;
		}
		hInst = hInstance;
		hWnd = CreateWindow(CLASS_NAME, CLASS_NAME, WS_OVERLAPPEDWINDOW
		  , rec.left, rec.top, width, height
		  , NULL, NULL, hInstance, NULL);
		ShowWindow(hWnd, SW_SHOW);
		UpdateWindow(hWnd);

		while(GetMessage(&msg, NULL, 0, 0)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	} else {
		MessageBox(GetDesktopWindow(), "Windows NT/2000/XP ŋNĂB", "Error", MB_OK);
	}
	return msg.wParam;
}

//
//	_CAO
//
BOOL APIENTRY UndoFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	static HWND hList;
	LV_DISPINFO *lvinfo;
	char temp[_MAX_PATH], name[_MAX_PATH];
	int no;

	switch(message) {
		case WM_INITDIALOG:
			set_dialog_center(hDlg);
			hList = init_undo_listview(hDlg);
			hItem = GetDlgItem(hDlg, IDOK);
			EnableWindow(hItem, FALSE);
			break;
		case WM_NOTIFY:
			lvinfo = (LV_DISPINFO *)lParam;
			if(lvinfo->hdr.code == LVN_ITEMCHANGED) {
				hItem = GetDlgItem(hDlg, IDOK);
				if(ListView_GetNextItem(hList, -1, LVNI_SELECTED) >= 0) {
					EnableWindow(hItem, TRUE);
				} else {
					EnableWindow(hItem, FALSE);
				}
			}
			break;
		case WM_ACTIVATE:
			if(LOWORD(wParam) != WA_INACTIVE) {
				SetFocus(hList);
			}
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					no = ListView_GetNextItem(hList, -1, LVNI_SELECTED);
					if(no >= 0) {
						if(undo_service(hDlg, hList, no)) {
							// [
							ListView_GetItemText(hList, no, HEADER_NAME, name, _MAX_PATH);
							wsprintf(temp, "T[rX %s 𕜊܂", name);
							MessageBox(hDlg, temp, "", MB_OK);

							EndDialog(hDlg, IDOK);
							break;
						}
					}
					break;
				case IDCANCEL:
					EndDialog(hDlg, IDCANCEL);
					break;
			}
			break;
		default:
			return FALSE;
	}
	return FALSE;
}

//
//	o[W
//
BOOL APIENTRY AboutFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message) {
		case WM_INITDIALOG:
			set_dialog_center(hDlg);
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					EndDialog(hDlg, IDOK);
					break;
			}
			break;
		default:
			return FALSE;
	}
	return FALSE;
}

//
//	Xgr[TuNX
//	ENbNŃj[\悤ɂ邽
//
LRESULT CALLBACK ListViewProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(Msg == WM_RBUTTONDOWN) {
		PostMessage(hMainWnd, WM_SHOW_POPUP_MENU, 0, 0);
		return TRUE;
	}
	return CallWindowProc(OldProc, hWnd, Msg, wParam, lParam);
}

//
//	Xgr[̃\[gpr֐
//
int CALLBACK listview_compare(LPARAM lp1, LPARAM lp2, LPARAM lps)
{
	static LV_FINDINFO fi;
	static int n1, n2;
	static char name1[_MAX_PATH], name2[_MAX_PATH];

	fi.flags = LVFI_PARAM;
	fi.lParam = lp1;
	n1 = ListView_FindItem(hList, -1, &fi);
	fi.lParam = lp2;
	n2 = ListView_FindItem(hList, -1, &fi);

	ListView_GetItemText(hList, n1, lps, name1, _MAX_PATH);
	ListView_GetItemText(hList, n2, lps, name2, _MAX_PATH);

	return strcmpi(name1, name2);
}

void set_all_status(HWND hWnd, HWND hTool, BOOL flag)
{
	HMENU hMenu = GetMenu(hWnd);
	int state;

	state = SendMessage(hTool, TB_GETSTATE, ID_MENU_ALL, 0);
	if(flag) {
		CheckMenuItem(hMenu, ID_MENU_ALL, MF_CHECKED);
		SendMessage(hTool, TB_SETSTATE, ID_MENU_ALL, state | TBSTATE_CHECKED);
	} else {
		CheckMenuItem(hMenu, ID_MENU_ALL, MF_UNCHECKED);
		SendMessage(hTool, TB_SETSTATE, ID_MENU_ALL, state & ~TBSTATE_CHECKED);
	}
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND hTool;
	static HWND hStatus;
	static BOOL all_flag;
	HMENU hMenu;
	POINT pt;
	char sname[_MAX_PATH], name[_MAX_PATH], temp[_MAX_PATH];
	int no;

	switch(msg) {
		case WM_CREATE:
			InitCommonControls();
			hTool = init_toolbar(hWnd);
			hStatus = init_status(hWnd);
			hList = init_listview(hWnd);
			all_flag = FALSE;
			add_listview(hList, all_flag);
			hMainWnd = hWnd;
			OldProc = (WNDPROC)GetWindowLong(hList, GWL_WNDPROC);
			SetWindowLong(hList, GWL_WNDPROC, (LONG)ListViewProc);
			check_history(hWnd, hTool);
			check_delete_button(hWnd, hList, hTool);
			set_all_status(hWnd, hTool, all_flag);
			break;

		case WM_ACTIVATE:
			if(LOWORD(wParam) != WA_INACTIVE) {
				SetFocus(hList);
			}
			break;

		case WM_SIZE:
			{ RECT rct, rcs;
			  int ht, hs;
			   GetWindowRect(hTool, &rct);
			   GetWindowRect(hStatus, &rcs);
			   ht = rct.bottom - rct.top;
			   hs = rcs.bottom - rcs.top;
			   SendMessage(hTool, WM_SIZE, wParam, lParam);
			   SendMessage(hStatus, WM_SIZE, wParam, lParam);
			   MoveWindow(hList, 0, ht, LOWORD(lParam), HIWORD(lParam) - ht - hs, TRUE);
			}
	
			break;

		case WM_NOTIFY:
			{
				LPNMHDR nm = (LPNMHDR)lParam;
				// c[o[̃c[`bv\p
				if(nm->code == TTN_NEEDTEXT) {
					LPTOOLTIPTEXT tt;
					tt = (LPTOOLTIPTEXT)lParam;
					tt->hinst = hInst;
					switch(tt->hdr.idFrom) {
						case ID_MENU_REFRESH:
							tt->lpszText = MAKEINTRESOURCE(IDS_REFRESH);
							break;
						case ID_MENU_SAVE:
							tt->lpszText = MAKEINTRESOURCE(IDS_SAVE);
							break;
						case ID_MENU_DELETE:
							tt->lpszText = MAKEINTRESOURCE(IDS_DELETE);
							break;
						case ID_MENU_UNDO:
							tt->lpszText = MAKEINTRESOURCE(IDS_UNDO);
							break;
						case ID_MENU_START:
							tt->lpszText = MAKEINTRESOURCE(IDS_START);
							break;
						case ID_MENU_STOP:
							tt->lpszText = MAKEINTRESOURCE(IDS_STOP);
							break;
						case ID_MENU_ALL:
							tt->lpszText = MAKEINTRESOURCE(IDS_ALL);
							break;
					}
				} else {
					NM_LISTVIEW *lvinfo = (NM_LISTVIEW *)lParam;
					// ږNbNŃ\[g
					if(lvinfo->hdr.code == LVN_COLUMNCLICK) {
						ListView_SortItems(lvinfo->hdr.hwndFrom, listview_compare, (LPARAM)lvinfo->iSubItem);
					// IԕωŃ{^⃁j[̏Ԃω
					} else if(lvinfo->hdr.code == LVN_ITEMCHANGED) {
						check_delete_button(hWnd, hList, hTool);
					}
				}
			}
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case ID_MENU_SAVE:
				// t@Cɕۑ
				write_csv(hWnd, hList);
				SetFocus(hList);
				break;
			case ID_MENU_DELETE:
				// T[rX폜
				if((no = ListView_GetNextItem(hList, -1, LVNI_SELECTED)) >= 0) {
					ListView_GetItemText(hList, no, HEADER_NAME, name, _MAX_PATH);
					ListView_GetItemText(hList, no, HEADER_SNAME, sname, _MAX_PATH);
					if(check_delete_service(hWnd, hList, no)) {
						wsprintf(temp, "T[rX %s 폜܂H", name);
						if(MessageBox(hWnd, temp, "폜̊mF", MB_YESNO) == IDYES) {
							if(delete_service(sname)) {
								add_history(hList, no);
								write_history();
								ListView_DeleteItem(hList, no);
								wsprintf(temp, "T[rX %s 폜܂", name);
								MessageBox(hWnd, temp, "폜", MB_OK);
								check_history(hWnd, hTool);
							} else {
								wsprintf(temp, "T[rX %s 폜ł܂ł", name);
								MessageBox(hWnd, temp, "폜", MB_OK);
							}
							add_listview(hList, all_flag);
							check_delete_button(hWnd, hList, hTool);
						}
					}
				}
				SetFocus(hList);
				break;

			case ID_MENU_UNDO:
				// _CAO\
				if(DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_UNDO), hWnd, (DLGPROC)UndoFunc) == IDOK) {
					add_listview(hList, all_flag);
					write_history();
					check_history(hWnd, hTool);
				}
				SetFocus(hList);
				break;

			case ID_MENU_REFRESH:
				// ꗗ\XV
				add_listview(hList, all_flag);
				check_delete_button(hWnd, hList, hTool);
				break;

			case ID_MENU_START:
				// T[rXJn
				if((no = ListView_GetNextItem(hList, -1, LVNI_SELECTED)) >= 0) {
					ListView_GetItemText(hList, no, HEADER_NAME, name, _MAX_PATH);
					ListView_GetItemText(hList, no, HEADER_SNAME, sname, _MAX_PATH);
					if(start_service(sname)) {
						wsprintf(temp, "%s Jn܂", name);
						MessageBox(hWnd, temp, "Jn", MB_OK);
					}
					add_listview(hList, all_flag);
					check_delete_button(hWnd, hList, hTool);
				}
				break;

			case ID_MENU_STOP:
				// T[rX~
				if((no = ListView_GetNextItem(hList, -1, LVNI_SELECTED)) >= 0) {
					ListView_GetItemText(hList, no, HEADER_NAME, name, _MAX_PATH);
					ListView_GetItemText(hList, no, HEADER_SNAME, sname, _MAX_PATH);
					if(stop_service(sname)) {
						wsprintf(temp, "%s ~܂", name);
						MessageBox(hWnd, temp, "~", MB_OK);
					}
					add_listview(hList, all_flag);
					check_delete_button(hWnd, hList, hTool);
				}
				break;

			case ID_MENU_ALL:
				// Sĕ\
				all_flag = !all_flag;
				set_all_status(hWnd, hTool, all_flag);
				add_listview(hList, all_flag);
				check_delete_button(hWnd, hList, hTool);
				break;

			case ID_MENU_ABOUT:
				// o[W\
				DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_ABOUT), hWnd, (DLGPROC)AboutFunc);
				SetFocus(hList);
				break;

			case ID_MENU_END:
				// I
				SendMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			}
			break;

		case WM_SHOW_POPUP_MENU:
			// |bvAbvj[\
			if((no = ListView_GetNextItem(hList, -1, LVNI_SELECTED)) >= 0) {
				hMenu = CreatePopupMenu();
				ListView_GetItemText(hList, no, HEADER_STATUS, temp, _MAX_PATH);
				if(!strcmp(temp, "Jn")) {
					AppendMenu(hMenu, MF_STRING | MF_GRAYED, ID_MENU_START, "Jn(&S)");
					AppendMenu(hMenu, MF_STRING, ID_MENU_STOP, "~(&O)");
				} else {
					AppendMenu(hMenu, MF_STRING, ID_MENU_START, "Jn(&S)");
					AppendMenu(hMenu, MF_STRING | MF_GRAYED, ID_MENU_STOP, "~(&O)");
				}
				AppendMenu(hMenu, MF_SEPARATOR, 0, 0);
				AppendMenu(hMenu, MF_STRING, ID_MENU_DELETE, "폜(&D)");
				GetCursorPos(&pt);
				SetForegroundWindow(hWnd);
				TrackPopupMenu(hMenu, TPM_TOPALIGN | TPM_LEFTALIGN, pt.x, pt.y, 0, hWnd, NULL);
				DestroyMenu(hMenu);
			}
			break;

		case WM_CLOSE:
			DestroyWindow(hWnd);
			break;

		case WM_DESTROY:
			delete_all_undo();
			ImageList_Destroy(hImage);
			write_ini(hWnd, hList);
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}

